// Code generated by protoc-gen-go. DO NOT EDIT.
// source: google/devtools/containeranalysis/v1/containeranalysis.proto

package containeranalysis // import "google.golang.org/genproto/googleapis/devtools/containeranalysis/v1"

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import _ "github.com/golang/protobuf/ptypes/timestamp"
import _ "google.golang.org/genproto/googleapis/api/annotations"
import v1 "google.golang.org/genproto/googleapis/iam/v1"

import (
	context "golang.org/x/net/context"
	grpc "google.golang.org/grpc"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// ContainerAnalysisClient is the client API for ContainerAnalysis service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://godoc.org/google.golang.org/grpc#ClientConn.NewStream.
type ContainerAnalysisClient interface {
	// Sets the access control policy on the specified note or occurrence.
	// Requires `containeranalysis.notes.setIamPolicy` or
	// `containeranalysis.occurrences.setIamPolicy` permission if the resource is
	// a note or an occurrence, respectively.
	//
	// The resource takes the format `projects/[PROJECT_ID]/notes/[NOTE_ID]` for
	// notes and `projects/[PROJECT_ID]/occurrences/[OCCURRENCE_ID]` for
	// occurrences.
	SetIamPolicy(ctx context.Context, in *v1.SetIamPolicyRequest, opts ...grpc.CallOption) (*v1.Policy, error)
	// Gets the access control policy for a note or an occurrence resource.
	// Requires `containeranalysis.notes.setIamPolicy` or
	// `containeranalysis.occurrences.setIamPolicy` permission if the resource is
	// a note or occurrence, respectively.
	//
	// The resource takes the format `projects/[PROJECT_ID]/notes/[NOTE_ID]` for
	// notes and `projects/[PROJECT_ID]/occurrences/[OCCURRENCE_ID]` for
	// occurrences.
	GetIamPolicy(ctx context.Context, in *v1.GetIamPolicyRequest, opts ...grpc.CallOption) (*v1.Policy, error)
	// Returns the permissions that a caller has on the specified note or
	// occurrence. Requires list permission on the project (for example,
	// `containeranalysis.notes.list`).
	//
	// The resource takes the format `projects/[PROJECT_ID]/notes/[NOTE_ID]` for
	// notes and `projects/[PROJECT_ID]/occurrences/[OCCURRENCE_ID]` for
	// occurrences.
	TestIamPermissions(ctx context.Context, in *v1.TestIamPermissionsRequest, opts ...grpc.CallOption) (*v1.TestIamPermissionsResponse, error)
}

type containerAnalysisClient struct {
	cc *grpc.ClientConn
}

func NewContainerAnalysisClient(cc *grpc.ClientConn) ContainerAnalysisClient {
	return &containerAnalysisClient{cc}
}

func (c *containerAnalysisClient) SetIamPolicy(ctx context.Context, in *v1.SetIamPolicyRequest, opts ...grpc.CallOption) (*v1.Policy, error) {
	out := new(v1.Policy)
	err := c.cc.Invoke(ctx, "/google.devtools.containeranalysis.v1.ContainerAnalysis/SetIamPolicy", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *containerAnalysisClient) GetIamPolicy(ctx context.Context, in *v1.GetIamPolicyRequest, opts ...grpc.CallOption) (*v1.Policy, error) {
	out := new(v1.Policy)
	err := c.cc.Invoke(ctx, "/google.devtools.containeranalysis.v1.ContainerAnalysis/GetIamPolicy", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *containerAnalysisClient) TestIamPermissions(ctx context.Context, in *v1.TestIamPermissionsRequest, opts ...grpc.CallOption) (*v1.TestIamPermissionsResponse, error) {
	out := new(v1.TestIamPermissionsResponse)
	err := c.cc.Invoke(ctx, "/google.devtools.containeranalysis.v1.ContainerAnalysis/TestIamPermissions", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ContainerAnalysisServer is the server API for ContainerAnalysis service.
type ContainerAnalysisServer interface {
	// Sets the access control policy on the specified note or occurrence.
	// Requires `containeranalysis.notes.setIamPolicy` or
	// `containeranalysis.occurrences.setIamPolicy` permission if the resource is
	// a note or an occurrence, respectively.
	//
	// The resource takes the format `projects/[PROJECT_ID]/notes/[NOTE_ID]` for
	// notes and `projects/[PROJECT_ID]/occurrences/[OCCURRENCE_ID]` for
	// occurrences.
	SetIamPolicy(context.Context, *v1.SetIamPolicyRequest) (*v1.Policy, error)
	// Gets the access control policy for a note or an occurrence resource.
	// Requires `containeranalysis.notes.setIamPolicy` or
	// `containeranalysis.occurrences.setIamPolicy` permission if the resource is
	// a note or occurrence, respectively.
	//
	// The resource takes the format `projects/[PROJECT_ID]/notes/[NOTE_ID]` for
	// notes and `projects/[PROJECT_ID]/occurrences/[OCCURRENCE_ID]` for
	// occurrences.
	GetIamPolicy(context.Context, *v1.GetIamPolicyRequest) (*v1.Policy, error)
	// Returns the permissions that a caller has on the specified note or
	// occurrence. Requires list permission on the project (for example,
	// `containeranalysis.notes.list`).
	//
	// The resource takes the format `projects/[PROJECT_ID]/notes/[NOTE_ID]` for
	// notes and `projects/[PROJECT_ID]/occurrences/[OCCURRENCE_ID]` for
	// occurrences.
	TestIamPermissions(context.Context, *v1.TestIamPermissionsRequest) (*v1.TestIamPermissionsResponse, error)
}

func RegisterContainerAnalysisServer(s *grpc.Server, srv ContainerAnalysisServer) {
	s.RegisterService(&_ContainerAnalysis_serviceDesc, srv)
}

func _ContainerAnalysis_SetIamPolicy_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(v1.SetIamPolicyRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContainerAnalysisServer).SetIamPolicy(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/google.devtools.containeranalysis.v1.ContainerAnalysis/SetIamPolicy",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContainerAnalysisServer).SetIamPolicy(ctx, req.(*v1.SetIamPolicyRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ContainerAnalysis_GetIamPolicy_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(v1.GetIamPolicyRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContainerAnalysisServer).GetIamPolicy(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/google.devtools.containeranalysis.v1.ContainerAnalysis/GetIamPolicy",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContainerAnalysisServer).GetIamPolicy(ctx, req.(*v1.GetIamPolicyRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ContainerAnalysis_TestIamPermissions_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(v1.TestIamPermissionsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContainerAnalysisServer).TestIamPermissions(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/google.devtools.containeranalysis.v1.ContainerAnalysis/TestIamPermissions",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContainerAnalysisServer).TestIamPermissions(ctx, req.(*v1.TestIamPermissionsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

var _ContainerAnalysis_serviceDesc = grpc.ServiceDesc{
	ServiceName: "google.devtools.containeranalysis.v1.ContainerAnalysis",
	HandlerType: (*ContainerAnalysisServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "SetIamPolicy",
			Handler:    _ContainerAnalysis_SetIamPolicy_Handler,
		},
		{
			MethodName: "GetIamPolicy",
			Handler:    _ContainerAnalysis_GetIamPolicy_Handler,
		},
		{
			MethodName: "TestIamPermissions",
			Handler:    _ContainerAnalysis_TestIamPermissions_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "google/devtools/containeranalysis/v1/containeranalysis.proto",
}

func init() {
	proto.RegisterFile("google/devtools/containeranalysis/v1/containeranalysis.proto", fileDescriptor_containeranalysis_50dd09dafa8381b2)
}

var fileDescriptor_containeranalysis_50dd09dafa8381b2 = []byte{
	// 393 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xb4, 0x93, 0x4f, 0x6a, 0xdb, 0x40,
	0x14, 0xc6, 0x91, 0x4b, 0xbb, 0x10, 0xdd, 0x54, 0xd0, 0x8d, 0x28, 0x35, 0x88, 0x2e, 0x5a, 0x2f,
	0x66, 0x70, 0xdb, 0x4d, 0xdd, 0x84, 0xe0, 0x78, 0x61, 0xb2, 0x33, 0xf9, 0xb3, 0xf1, 0x26, 0x8c,
	0x27, 0x2f, 0x62, 0x82, 0x66, 0x9e, 0x32, 0x33, 0x12, 0x38, 0x21, 0x60, 0xb2, 0xc8, 0x05, 0x72,
	0x83, 0x5c, 0x24, 0x87, 0xc8, 0x15, 0xb2, 0xcc, 0x21, 0x82, 0xa4, 0x51, 0xb0, 0x2d, 0xc7, 0x98,
	0x40, 0x96, 0xf3, 0xbe, 0xf7, 0x7d, 0xf3, 0xfd, 0x60, 0xc6, 0xdf, 0x8a, 0x11, 0xe3, 0x04, 0xe8,
	0x09, 0xe4, 0x16, 0x31, 0x31, 0x94, 0xa3, 0xb2, 0x4c, 0x28, 0xd0, 0x4c, 0xb1, 0x64, 0x6a, 0x84,
	0xa1, 0x79, 0xb7, 0x39, 0x24, 0xa9, 0x46, 0x8b, 0xc1, 0x8f, 0xca, 0x4d, 0x6a, 0x37, 0x69, 0x2e,
	0xe6, 0xdd, 0xf0, 0x9b, 0xbb, 0x83, 0xa5, 0x82, 0x32, 0xa5, 0xd0, 0x32, 0x2b, 0x50, 0xb9, 0x8c,
	0xf0, 0xbb, 0x53, 0x05, 0x93, 0xc5, 0x55, 0x82, 0xc9, 0xe3, 0x14, 0x13, 0xc1, 0xa7, 0x4e, 0x0f,
	0x17, 0xf5, 0x05, 0xad, 0xed, 0xb4, 0xf2, 0x34, 0xc9, 0x4e, 0xa9, 0x15, 0x12, 0x8c, 0x65, 0x32,
	0xad, 0x16, 0x7e, 0xdf, 0x7c, 0xf4, 0xbf, 0x0c, 0xea, 0x4e, 0x7d, 0xd7, 0x29, 0xb8, 0xf7, 0xfc,
	0xcf, 0x07, 0x60, 0xf7, 0x98, 0x1c, 0x95, 0x69, 0x41, 0x44, 0x1c, 0x88, 0x60, 0x92, 0xe4, 0x5d,
	0x32, 0x2f, 0xee, 0xc3, 0x79, 0x06, 0xc6, 0x86, 0x5f, 0x97, 0x76, 0x2a, 0x35, 0xb2, 0xd7, 0x0f,
	0x8f, 0xb7, 0x2d, 0x15, 0x91, 0xa2, 0xdc, 0xa5, 0x06, 0x83, 0x99, 0xe6, 0xb0, 0x9d, 0x6a, 0x3c,
	0x03, 0x6e, 0x0d, 0xed, 0x50, 0x85, 0x16, 0x0c, 0xed, 0x5c, 0xf5, 0xcc, 0x5c, 0x6a, 0xcf, 0xeb,
	0x8c, 0xff, 0x45, 0x7f, 0x5f, 0x35, 0x21, 0xe7, 0x99, 0xd6, 0xa0, 0xf8, 0x4a, 0x6b, 0x49, 0x30,
	0x5c, 0x47, 0x30, 0x7c, 0x17, 0x82, 0xf8, 0xed, 0x04, 0x4b, 0xd6, 0xe0, 0xc9, 0xf3, 0x83, 0x43,
	0x30, 0xe5, 0x10, 0xb4, 0x14, 0xc6, 0x14, 0x6f, 0x22, 0xf8, 0xb9, 0xd4, 0xb1, 0xb9, 0x52, 0xd3,
	0xfc, 0xda, 0x60, 0xd3, 0xa4, 0xa8, 0x0c, 0x44, 0x33, 0xaf, 0x44, 0xbc, 0x58, 0xd3, 0xf6, 0x05,
	0xd1, 0x36, 0x62, 0x0a, 0xd0, 0x9d, 0xa8, 0xb7, 0x29, 0xe8, 0xca, 0x80, 0xdd, 0x99, 0xe7, 0xb7,
	0x39, 0xca, 0xba, 0xf3, 0xaa, 0x7f, 0x32, 0xf2, 0xc6, 0x47, 0x4e, 0x8e, 0x31, 0x61, 0x2a, 0x26,
	0xa8, 0x63, 0x1a, 0x83, 0x2a, 0x9f, 0x32, 0xad, 0x24, 0x96, 0x0a, 0xb3, 0xfe, 0xb3, 0xfe, 0x6f,
	0x0c, 0xef, 0x5a, 0x1f, 0x86, 0x83, 0xfe, 0xe4, 0x53, 0x99, 0xf3, 0xe7, 0x39, 0x00, 0x00, 0xff,
	0xff, 0xba, 0xe6, 0x43, 0xb1, 0xf3, 0x03, 0x00, 0x00,
}
